"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _active = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/active"));

var _linkByColor = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/link-by-color"));

var _rangeActive = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/range-active"));

var _singleActive = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/single-active"));

var _highlight = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/highlight"));

var _highlightByX = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/highlight-by-x"));

var _highlightByColor = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/highlight-by-color"));

var _singleHighlight = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/single-highlight"));

var _rangeHighlight = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/range-highlight"));

var _selected = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/selected"));

var _singleSelected = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/single-selected"));

var _rangeSelected = _interopRequireDefault(require("@antv/g2/lib/interaction/action/element/range-selected"));

var _cursor = _interopRequireDefault(require("@antv/g2/lib/interaction/action/cursor"));

var _core = require("../core");

// TODO: 按照element 详细分类
(0, _core.registerAction)('cursor', _cursor["default"]);
(0, _core.registerAction)('element-active', _active["default"]);
(0, _core.registerAction)('element-single-active', _singleActive["default"]);
(0, _core.registerAction)('element-range-active', _rangeActive["default"]);
(0, _core.registerAction)('element-highlight', _highlight["default"]);
(0, _core.registerAction)('element-highlight-by-x', _highlightByX["default"]);
(0, _core.registerAction)('element-highlight-by-color', _highlightByColor["default"]);
(0, _core.registerAction)('element-single-highlight', _singleHighlight["default"]);
(0, _core.registerAction)('element-range-highlight', _rangeHighlight["default"]);
(0, _core.registerAction)('element-sibling-highlight', _rangeHighlight["default"], {
  effectSiblings: true,
  effectByRecord: true
});
(0, _core.registerAction)('element-selected', _selected["default"]);
(0, _core.registerAction)('element-single-selected', _singleSelected["default"]);
(0, _core.registerAction)('element-range-selected', _rangeSelected["default"]);
(0, _core.registerAction)('element-link-by-color', _linkByColor["default"]); // 移动到 elment 上 active

(0, _core.registerInteraction)('element-active', {
  start: [{
    trigger: 'element:mouseenter',
    action: 'element-active:active'
  }],
  end: [{
    trigger: 'element:mouseleave',
    action: 'element-active:reset'
  }]
}); // 点击选中，允许取消

(0, _core.registerInteraction)('element-selected', {
  start: [{
    trigger: 'element:click',
    action: 'element-selected:toggle'
  }]
}); // hover highlight，允许取消

(0, _core.registerInteraction)('element-highlight', {
  start: [{
    trigger: 'element:mouseenter',
    action: 'element-highlight:highlight'
  }],
  end: [{
    trigger: 'element:mouseleave',
    action: 'element-highlight:reset'
  }]
}); // hover highlight by x，允许取消

(0, _core.registerInteraction)('element-highlight-by-x', {
  start: [{
    trigger: 'element:mouseenter',
    action: 'element-highlight-by-x:highlight'
  }],
  end: [{
    trigger: 'element:mouseleave',
    action: 'element-highlight-by-x:reset'
  }]
}); // hover highlight by y，允许取消

(0, _core.registerInteraction)('element-highlight-by-color', {
  start: [{
    trigger: 'element:mouseenter',
    action: 'element-highlight-by-color:highlight'
  }],
  end: [{
    trigger: 'element:mouseleave',
    action: 'element-highlight-by-color:reset'
  }]
});