"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.polyfill = void 0;

require("react");

var _bar = require("@antv/g2plot/lib/plots/bar");

var _createPlot = _interopRequireDefault(require("../createPlot"));

var _polyfill = require("./core/polyfill");

var _util = require("@antv/util");

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var polyfill = function polyfill(opt) {
  var _a = (0, _polyfill.polyfillOptions)(opt),
      barSize = _a.barSize,
      options = __rest(_a, ["barSize"]);

  (0, _polyfill.replaceApi)([{
    sourceKey: 'stackField',
    targetKey: 'seriesField',
    notice: 'stackField是旧版API，即将废弃 请使用seriesField替代'
  }, {
    sourceKey: 'colorField',
    targetKey: 'seriesField',
    notice: 'colorField是旧版API，即将废弃 请使用seriesField替代'
  }], options);

  if (!(0, _util.isNil)(barSize)) {
    options.minBarWidth = barSize;
    options.maxBarWidth = barSize;
  }

  return options;
};

exports.polyfill = polyfill;

var _default = (0, _createPlot["default"])(_bar.Bar, 'BarChart', polyfill);

exports["default"] = _default;