"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("react");

var _treemap = require("@antv/g2plot/lib/plots/treemap");

var _createPlot = _interopRequireDefault(require("../createPlot"));

var _polyfill = require("./core/polyfill");

var _util = require("@antv/util");

var _warning = _interopRequireDefault(require("warning"));

var formatDataByMaxlevel = function formatDataByMaxlevel(data, maxLevel) {
  var curLevel = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

  if (curLevel > maxLevel) {
    delete data.children;
  } else {
    var children = data.children;

    if (children && children.length) {
      children.forEach(function (it) {
        formatDataByMaxlevel(it, maxLevel, curLevel + 1);
      });
    }
  }
};

var polyfill = function polyfill(opt) {
  var options = (0, _polyfill.polyfillOptions)(opt);
  var maxLevel = (0, _util.get)(options, 'maxLevel', 2);

  if (!(0, _util.isNil)(maxLevel)) {
    if (maxLevel < 1) {
      (0, _warning["default"])(false, 'maxLevel 必须大于等于1');
    } else {
      var data = (0, _util.get)(options, 'data', {});
      formatDataByMaxlevel(data, maxLevel);
      (0, _util.set)(options, 'data', data);
      (0, _util.set)(options, 'maxLevel', maxLevel);
    }
  }

  return options;
};

var _default = (0, _createPlot["default"])(_treemap.Treemap, 'TreemapChart', polyfill);

exports["default"] = _default;