"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _object = _interopRequireDefault(require("object.assign"));

var _forIn2 = _interopRequireDefault(require("@antv/util/lib/for-in"));

var _sum = _interopRequireDefault(require("./sum"));

var _warning = _interopRequireDefault(require("warning"));

var _partition = _interopRequireDefault(require("./partition"));

// 只列举常用的函数，复杂的推荐使用第三方类库。

/**
 * 百分比计算, 不支持重复数据统计
 * @param data object[] 数据源
 * @param field string 被统计的值
 * @param as string 生成的百分比字段名
 * @param groupBy : string | string[] 将数据分组后再计算百分比
 */
var _default2 = function _default2(data, field, as, groupBy) {
  var result = [];
  var groups = groupBy ? (0, _partition["default"])(data, groupBy) : {
    _data: data
  };
  (0, _forIn2["default"])(groups, function (group) {
    var totalSum = (0, _sum["default"])(group.map(function (row) {
      return row[field];
    }));
    (0, _warning["default"])(totalSum !== 0, "Invalid data: total sum of field ".concat(field, " is 0!"));
    (0, _forIn2["default"])(group, function (item) {
      var resultRow = (0, _object["default"])({}, item);

      if (totalSum === 0) {
        resultRow[as] = 0;
      } else {
        resultRow[as] = item[field] / totalSum;
      }

      result.push(resultRow);
    });
  });
  return result;
};

exports["default"] = _default2;