"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = sortBy;

var _isArray = _interopRequireDefault(require("@antv/util/lib/is-array"));

var _isFunction = _interopRequireDefault(require("@antv/util/lib/is-function"));

var _isString = _interopRequireDefault(require("@antv/util/lib/is-string"));

// from g2-dataSte
function sortBy(arr) {
  var keys = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var comparer;

  if ((0, _isFunction["default"])(keys)) {
    comparer = keys;
  } else if ((0, _isArray["default"])(keys)) {
    comparer = function comparer(a, b) {
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];

        if (a[key] < b[key]) {
          return -1;
        }

        if (a[key] > b[key]) {
          return 1;
        }
      }

      return 0;
    };
  } else if ((0, _isString["default"])(keys)) {
    comparer = function comparer(a, b) {
      if (a[keys] < b[keys]) {
        return -1;
      }

      if (a[keys] > b[keys]) {
        return 1;
      }

      return 0;
    };
  }

  return arr.sort(comparer);
}