"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _object = _interopRequireDefault(require("object.assign"));

var _isFunction2 = _interopRequireDefault(require("@antv/util/lib/is-function"));

var _circle = _interopRequireDefault(require("@antv/g2/lib/facet/circle"));

var _list = _interopRequireDefault(require("@antv/g2/lib/facet/list"));

var _matrix = _interopRequireDefault(require("@antv/g2/lib/facet/matrix"));

var _mirror = _interopRequireDefault(require("@antv/g2/lib/facet/mirror"));

var _rect = _interopRequireDefault(require("@antv/g2/lib/facet/rect"));

var _tree = _interopRequireDefault(require("@antv/g2/lib/facet/tree"));

var _useChartView = _interopRequireDefault(require("../../hooks/useChartView"));

var _core = require("../../core");

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

(0, _core.registerFacet)('rect', _rect["default"]);
(0, _core.registerFacet)('mirror', _mirror["default"]);
(0, _core.registerFacet)('list', _list["default"]);
(0, _core.registerFacet)('matrix', _matrix["default"]);
(0, _core.registerFacet)('circle', _circle["default"]);
(0, _core.registerFacet)('tree', _tree["default"]);
;

function Facet(props) {
  var chart = (0, _useChartView["default"])();

  var type = props.type,
      children = props.children,
      cfg = __rest(props, ["type", "children"]);

  if ((0, _isFunction2["default"])(children)) {
    chart.facet(type, (0, _object["default"])((0, _object["default"])({}, cfg), {
      // @ts-ignore
      eachView: children
    }));
  } else {
    chart.facet(type, (0, _object["default"])({}, cfg));
  }

  return null;
}

var _default2 = Facet;
exports["default"] = _default2;