"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _listHighlight = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/list-highlight"));

var _listActive = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/list-active"));

var _listUnchecked = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/list-unchecked"));

var _filter = _interopRequireDefault(require("@antv/g2/lib/interaction/action/data/filter"));

var _listSelected = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/list-selected"));

var _core = require("../../core");

(0, _core.registerAction)('list-active', _listActive["default"]);
(0, _core.registerAction)('list-selected', _listSelected["default"]);
(0, _core.registerAction)('list-highlight', _listHighlight["default"]);
(0, _core.registerAction)('list-unchecked', _listUnchecked["default"]); // 筛选数据

(0, _core.registerAction)('data-filter', _filter["default"]);
(0, _core.registerAction)('legend-item-highlight', _listHighlight["default"], {
  componentNames: ['legend']
});
(0, _core.registerInteraction)('legend-active', {
  start: [{
    trigger: 'legend-item:mouseenter',
    action: ['list-active:active', 'element-active:active']
  }],
  end: [{
    trigger: 'legend-item:mouseleave',
    action: ['list-active:reset', 'element-active:reset']
  }]
}); // legend hover，element active

(0, _core.registerInteraction)('legend-highlight', {
  start: [{
    trigger: 'legend-item:mouseenter',
    action: ['legend-item-highlight:highlight', 'element-highlight:highlight']
  }],
  end: [{
    trigger: 'legend-item:mouseleave',
    action: ['legend-item-highlight:reset', 'element-highlight:reset']
  }]
});
(0, _core.registerInteraction)('legend-filter', {
  showEnable: [{
    trigger: 'legend-item:mouseenter',
    action: 'cursor:pointer'
  }, {
    trigger: 'legend-item:mouseleave',
    action: 'cursor:default'
  }],
  start: [{
    trigger: 'legend-item:click',
    action: 'list-unchecked:toggle'
  }, {
    trigger: 'legend-item:click',
    action: 'data-filter:filter'
  }]
});