"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _activeRegion = _interopRequireDefault(require("@antv/g2/lib/interaction/action/active-region"));

var _sibling = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/tooltip/sibling"));

var _geometry = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/tooltip/geometry"));

var _ellipsisText = _interopRequireDefault(require("@antv/g2/lib/interaction/action/component/tooltip/ellipsis-text"));

var _core = require("../../core");

(0, _core.registerAction)('tooltip', _geometry["default"]);
(0, _core.registerAction)('sibling-tooltip', _sibling["default"]);
(0, _core.registerAction)('active-region', _activeRegion["default"]);
(0, _core.registerAction)('ellipsis-text', _ellipsisText["default"]); // 注册 tooltip 的 interaction

(0, _core.registerInteraction)('tooltip', {
  start: [{
    trigger: 'plot:mousemove',
    action: 'tooltip:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }, {
    trigger: 'plot:touchmove',
    action: 'tooltip:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }],
  end: [{
    trigger: 'plot:mouseleave',
    action: 'tooltip:hide'
  }, {
    trigger: 'plot:leave',
    action: 'tooltip:hide'
  }, {
    trigger: 'plot:touchend',
    action: 'tooltip:hide'
  }]
});
(0, _core.registerInteraction)('ellipsis-text', {
  start: [{
    trigger: 'legend-item-name:mousemove',
    action: 'ellipsis-text:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }, {
    trigger: 'legend-item-name:touchstart',
    action: 'ellipsis-text:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }, {
    trigger: 'axis-label:mousemove',
    action: 'ellipsis-text:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }, {
    trigger: 'axis-label:touchstart',
    action: 'ellipsis-text:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }],
  end: [{
    trigger: 'legend-item-name:mouseleave',
    action: 'ellipsis-text:hide'
  }, {
    trigger: 'legend-item-name:touchend',
    action: 'ellipsis-text:hide'
  }, {
    trigger: 'axis-label:mouseleave',
    action: 'ellipsis-text:hide'
  }, {
    trigger: 'axis-label:touchend',
    action: 'ellipsis-text:hide'
  }]
}); // click 触发

(0, _core.registerInteraction)('tooltip-click', {
  start: [{
    trigger: 'plot:click',
    action: 'tooltip:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }, {
    trigger: 'plot:touchstart',
    action: 'tooltip:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }],
  end: [{
    trigger: 'plot:leave',
    action: 'tooltip:hide'
  }]
}); // tooltip 跟随和不跟随之间切换

var toggleLock = function toggleLock(context) {
  var locked = context.view.isTooltipLocked();

  if (locked) {
    context.view.unlockTooltip();
  } else {
    context.view.lockTooltip();
  }
};

(0, _core.registerInteraction)('tooltip-lock', {
  start: [{
    trigger: 'plot:click',
    action: toggleLock
  }, {
    trigger: 'plot:touchstart',
    action: toggleLock
  }, {
    trigger: 'plot:touchmove',
    action: 'tooltip:show',
    throttle: {
      wait: 50,
      leading: true,
      trailing: false
    }
  }, {
    trigger: 'plot:mousemove',
    action: 'tooltip:show'
  }],
  end: [{
    trigger: 'plot:click',
    action: 'tooltip:hide'
  }, {
    trigger: 'plot:leave',
    action: 'tooltip:hide'
  }, {
    trigger: 'plot:touchend',
    action: 'tooltip:hide'
  }]
}); // 注册 sibling-tooltip 的 interaction

(0, _core.registerInteraction)('sibling-tooltip', {
  start: [{
    trigger: 'plot:mousemove',
    action: 'sibling-tooltip:show'
  }],
  end: [{
    trigger: 'plot:mouseleave',
    action: 'sibling-tooltip:hide'
  }]
});