"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _object = _interopRequireDefault(require("object.assign"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _react = _interopRequireDefault(require("react"));

var _gCanvas = require("@antv/g-canvas");

var _gSvg = require("@antv/g-svg");

var _withContainer = _interopRequireDefault(require("../boundary/withContainer"));

var _ErrorBoundary = _interopRequireDefault(require("../boundary/ErrorBoundary"));

var _canvas = _interopRequireDefault(require("../context/canvas"));

var _group = _interopRequireDefault(require("../context/group"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var CanvasHelper = /*#__PURE__*/function () {
  function CanvasHelper() {
    (0, _classCallCheck2["default"])(this, CanvasHelper);
  }

  (0, _createClass2["default"])(CanvasHelper, [{
    key: "createInstance",
    value: function createInstance(props) {
      var children = props.children,
          renderer = props.renderer,
          config = __rest(props, ["children", "renderer"]);

      if (renderer === 'svg') {
        this.instance = new _gSvg.Canvas((0, _object["default"])({}, config));
      } else {
        this.instance = new _gCanvas.Canvas((0, _object["default"])({}, config));
      }
    }
  }, {
    key: "update",
    value: function update(newConfig) {
      if (!this.instance) {
        this.createInstance(newConfig);
      }
    }
  }, {
    key: "draw",
    value: function draw() {
      if (!this.instance) {
        return;
      }

      this.instance.draw();
    }
  }, {
    key: "destory",
    value: function destory() {
      if (this.instance) {
        this.instance.remove();
        this.instance = null;
      }
    }
  }]);
  return CanvasHelper;
}();

var Canvas = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Canvas, _React$Component);

  var _super = _createSuper(Canvas);

  function Canvas(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Canvas);
    _this = _super.call(this, props);
    _this.helper = new CanvasHelper();
    return _this;
  }

  (0, _createClass2["default"])(Canvas, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.helper.draw();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.helper.destory();
    }
  }, {
    key: "getInstance",
    value: function getInstance() {
      return this.helper.instance;
    }
  }, {
    key: "render",
    value: function render() {
      this.helper.update(this.props);
      return /*#__PURE__*/_react["default"].createElement(_ErrorBoundary["default"], (0, _object["default"])({}, this.props.ErrorBoundaryProps), /*#__PURE__*/_react["default"].createElement(_canvas["default"].Provider, {
        value: this.helper
      }, /*#__PURE__*/_react["default"].createElement(_group["default"].Provider, {
        value: this.helper.instance
      }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, this.props.children))));
    }
  }]);
  return Canvas;
}(_react["default"].Component);

var _default2 = (0, _withContainer["default"])(Canvas);

exports["default"] = _default2;