"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("react");

var _get = _interopRequireDefault(require("@antv/util/lib/get"));

var _set = _interopRequireDefault(require("@antv/util/lib/set"));

var _rose = require("@antv/g2plot/lib/plots/rose");

var _createPlot = _interopRequireDefault(require("../createPlot"));

var _polyfill = require("./core/polyfill");

var REPLACEAPILIST = [{
  sourceKey: 'colorField',
  targetKey: 'seriesField',
  notice: 'colorField 是 g2@1.0的属性，即将废弃，请使用seriesField替代'
}, {
  sourceKey: 'categoryField',
  targetKey: 'xField',
  notice: 'categoryField 是 g2@1.0的属性，即将废弃，请使用xField替代'
}, {
  sourceKey: 'radiusField',
  targetKey: 'yField',
  notice: 'radiusField 是 g2@1.0的属性，即将废弃，请使用yFeild替代'
}];

var polyfill = function polyfill(opt) {
  var options = (0, _polyfill.polyfillOptions)(opt);
  (0, _polyfill.replaceApi)(REPLACEAPILIST, options);

  if ((0, _get["default"])(options, 'tooltip.visible') === false) {
    (0, _set["default"])(options, 'tooltip', false);
  }

  if ((0, _get["default"])(options, 'label.visible') === false) {
    (0, _set["default"])(options, 'label', false);
  }

  if ((0, _get["default"])(options, 'label.type') === 'inner') {
    options.label.offset = -15;
    delete options.label.type;
  }

  if ((0, _get["default"])(options, 'label.type') === 'outer') {
    delete options.label.type;
  }

  return options;
};

var _default = (0, _createPlot["default"])(_rose.Rose, 'RoseChart', polyfill);

exports["default"] = _default;