"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("react");

var _get = _interopRequireDefault(require("@antv/util/lib/get"));

var _set = _interopRequireDefault(require("@antv/util/lib/set"));

var _scatter = require("@antv/g2plot/lib/plots/scatter");

var _createPlot = _interopRequireDefault(require("../createPlot"));

var _polyfill = require("./core/polyfill");

var _util = require("@antv/util");

var polyfill = function polyfill(opt) {
  var options = (0, _polyfill.polyfillOptions)(opt);

  if ((0, _get["default"])(options, 'pointSize')) {
    (0, _set["default"])(options, 'size', (0, _get["default"])(options, 'pointSize'));
  }

  (0, _polyfill.polyfillVisible)(options, 'quadrant');
  var quadrantLabel = (0, _get["default"])(options, 'quadrant.label');
  var qLabels = (0, _get["default"])(options, 'quadrant.labels');

  if (!qLabels && quadrantLabel) {
    var text = quadrantLabel.text,
        style = quadrantLabel.style;

    if (text && text.length && style) {
      var labels = text.map(function (txt) {
        return {
          style: style,
          content: txt
        };
      });
      (0, _set["default"])(options, 'quadrant.labels', labels);
    }
  }

  var regressionLine = (0, _get["default"])(options, 'regressionLine');

  if (!regressionLine) {
    var trendline = (0, _get["default"])(options, 'trendline');

    if ((0, _util.isObject)(trendline) && (0, _get["default"])(trendline, 'visible') === false) {
      (0, _set["default"])(options, 'regressionLine', null);
    } else {
      (0, _set["default"])(options, 'regressionLine', trendline);
    }
  }

  return options;
};

var _default = (0, _createPlot["default"])(_scatter.Scatter, 'ScatterChart', polyfill);

exports["default"] = _default;